"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _nocmsEvents = require("nocms-events");

var _draftJs = require("draft-js");

var _draftJsExportHtml = require("draft-js-export-html");

var _draftJsImportHtml = require("draft-js-import-html");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PlainTextEditor =
/*#__PURE__*/
function (_Component) {
  _inherits(PlainTextEditor, _Component);

  function PlainTextEditor(props) {
    var _this;

    _classCallCheck(this, PlainTextEditor);

    _this = _possibleConstructorReturn(this, (PlainTextEditor.__proto__ || Object.getPrototypeOf(PlainTextEditor)).call(this, props));
    var convertedText = (0, _draftJsImportHtml.stateFromHTML)(props.text);
    _this.state = {
      editorState: _draftJs.EditorState.createWithContent(convertedText, _this.decorator)
    };

    _this.onChange = function (editorState) {
      return _this.setState({
        editorState: editorState
      });
    }; //eslint-disable-line


    _this.onBlur = _this.onBlur.bind(_this);
    return _this;
  }

  _createClass(PlainTextEditor, [{
    key: "onBlur",
    value: function onBlur() {
      var html = (0, _draftJsExportHtml.stateToHTML)(this.state.editorState.getCurrentContent());

      if (html === this.props.text) {
        return;
      }

      (0, _nocmsEvents.triggerGlobal)('nocms.value-changed', this.props.scope, html);
    }
  }, {
    key: "render",
    value: function render() {
      var placeholder = this.props.placeholder;
      return _react.default.createElement("div", {
        className: "text-editor"
      }, _react.default.createElement("div", {
        className: "text-editor__body"
      }, _react.default.createElement(_draftJs.Editor, {
        editorState: this.state.editorState,
        onChange: this.onChange,
        placeholder: placeholder,
        onBlur: this.onBlur
      })));
    }
  }]);

  return PlainTextEditor;
}(_react.Component);

PlainTextEditor.propTypes = {
  text: _propTypes.default.string,
  scope: _propTypes.default.string,
  placeholder: _propTypes.default.string
};
PlainTextEditor.defaultProps = {
  text: ''
};
var _default = PlainTextEditor;
exports.default = _default;
//# sourceMappingURL=PlainTextEditor.js.map