"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _nocmsEvents = require("nocms-events");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_HEIGHT = 70;
var textareaClass = 'nocms__text-input nocms__textarea';
var centerClass = 'nocms__text-input--center'; // Based on the work of http://dev.edenspiekermann.com/2016/08/26/react-textarea-auto-resize/

var SimpleMultiline =
/*#__PURE__*/
function (_React$Component) {
  _inherits(SimpleMultiline, _React$Component);

  function SimpleMultiline(props) {
    var _this;

    _classCallCheck(this, SimpleMultiline);

    _this = _possibleConstructorReturn(this, (SimpleMultiline.__proto__ || Object.getPrototypeOf(SimpleMultiline)).call(this, props));
    _this.onChange = _this.onChange.bind(_this);
    _this.state = {
      height: DEFAULT_HEIGHT
    };
    _this.setFilledTextareaHeight = _this.setFilledTextareaHeight.bind(_this);
    return _this;
  }

  _createClass(SimpleMultiline, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.autoresize) {
        this.mounted = true;
        this.setFilledTextareaHeight();
      }
    }
  }, {
    key: "onChange",
    value: function onChange(event) {
      (0, _nocmsEvents.triggerGlobal)('nocms.value-changed', this.props.scope, event.target.value);
    }
  }, {
    key: "setFilledTextareaHeight",
    value: function setFilledTextareaHeight() {
      if (this.mounted) {
        var element = this.ghost;
        this.setState({
          height: element.clientHeight
        });
      }
    }
  }, {
    key: "getExpandableField",
    value: function getExpandableField() {
      var isOneLine = this.state.height <= DEFAULT_HEIGHT;
      var height = this.state.height;
      var _props = this.props,
          center = _props.center,
          placeholder = _props.placeholder,
          text = _props.text;
      var centerTextInput = center ? "".concat(textareaClass, " ").concat(centerClass) : textareaClass;
      return _react.default.createElement("textarea", {
        className: centerTextInput,
        name: "textarea",
        value: text,
        placeholder: placeholder,
        style: {
          height: height,
          resize: isOneLine ? 'none' : null
        },
        onChange: this.onChange,
        onKeyUp: this.setFilledTextareaHeight
      });
    }
    /* eslint no-return-assign: off */

  }, {
    key: "getGhostField",
    value: function getGhostField() {
      var _this2 = this;

      return _react.default.createElement("div", {
        className: "nocms__text-input nocms__textarea nocms__textarea--ghost",
        ref: function ref(c) {
          return _this2.ghost = c;
        },
        "aria-hidden": "true"
      }, this.props.text);
    }
  }, {
    key: "render",
    value: function render() {
      var _props2 = this.props,
          center = _props2.center,
          text = _props2.text,
          placeholder = _props2.placeholder,
          autoresize = _props2.autoresize;
      var className = center ? "".concat(textareaClass, " ").concat(centerClass) : textareaClass;
      return _react.default.createElement("div", null, autoresize ? _react.default.createElement("div", {
        className: "textarea-wrapper"
      }, this.getExpandableField(), this.getGhostField()) : _react.default.createElement("textarea", {
        className: className,
        value: text,
        placeholder: placeholder,
        onChange: this.onChange
      }));
    }
  }]);

  return SimpleMultiline;
}(_react.default.Component);

SimpleMultiline.propTypes = {
  text: _propTypes.default.string,
  placeholder: _propTypes.default.string,
  scope: _propTypes.default.string,
  center: _propTypes.default.bool,
  autoresize: _propTypes.default.bool
};
SimpleMultiline.defaultProps = {
  text: '',
  placeholder: 'Add text...',
  center: false,
  autoresize: true
};
var _default = SimpleMultiline;
exports.default = _default;
//# sourceMappingURL=SimpleMultiline.js.map