"use strict";

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FormattingButton = _interopRequireDefault(require("./FormattingButton"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BLOCK_TYPES = [{
  label: 'UL',
  style: 'unordered-list-item'
}, {
  label: 'OL',
  style: 'ordered-list-item'
}];

var BlockStyleControls = function BlockStyleControls(props) {
  var editorState = props.editorState;
  var selection = editorState.getSelection();
  var blockType = editorState.getCurrentContent().getBlockForKey(selection.getStartKey()).getType();
  return _react.default.createElement("span", {
    className: "text-editor__formatting"
  }, BLOCK_TYPES.map(function (type) {
    return _react.default.createElement(_FormattingButton.default, {
      key: type.label,
      active: type.style === blockType,
      label: type.label,
      onToggle: props.onToggle,
      style: type.style
    });
  }));
};

BlockStyleControls.propTypes = {
  editorState: _propTypes.default.object,
  onToggle: _propTypes.default.func
};
module.exports = BlockStyleControls;
//# sourceMappingURL=BlockStyleControls.js.map