"use strict";

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FormattingButton = _interopRequireDefault(require("./FormattingButton"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var INLINE_STYLES = [{
  label: 'B',
  style: 'BOLD'
}, {
  label: 'I',
  style: 'ITALIC'
}, {
  label: 'U',
  style: 'UNDERLINE'
}];

var FormattingControls = function FormattingControls(props) {
  var currentStyle = props.editorState.getCurrentInlineStyle();
  return _react.default.createElement("span", {
    className: "text-editor__formatting"
  }, INLINE_STYLES.map(function (type) {
    return _react.default.createElement(_FormattingButton.default, {
      key: type.label,
      active: currentStyle.has(type.style),
      label: type.label,
      onToggle: props.onToggle,
      style: type.style
    });
  }));
};

FormattingControls.propTypes = {
  editorState: _propTypes.default.object,
  onToggle: _propTypes.default.func
};
module.exports = FormattingControls;
//# sourceMappingURL=FormattingControls.js.map